var IdentityReminder = {
  consoleService: Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService),

  queryISupportsArray: function(supportsArray,iid) {
     var result = new Array;
     for (var i=0; i<supportsArray.Count(); i++) {
       // dump(i + "," + result[i] + "\n");
       result[i] = supportsArray.QueryElementAt(i, iid);
     }
     return result;
  },

  onLoad: function() {
    var gAccountManager = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);

    var accounts = IdentityReminder.queryISupportsArray(gAccountManager.accounts, Components.interfaces.nsIMsgAccount);

    // accounts.sort(compareAccountSortOrder); TODO!!

    var menulist = document.getElementById('msgIdentity');
    for (var i in accounts) {
        var server = accounts[i].incomingServer;
        if (!server)
            continue;

        var identites = IdentityReminder.queryISupportsArray(accounts[i].identities, Components.interfaces.nsIMsgIdentity);

        for (var j in identites) {
             var identity = identites[j];
             var item = menulist.appendItem(identity.identityName, identity.key, server.prettyName);
             item.setAttribute("accountkey", accounts[i].key);
        }
    }
    menulist.selectedIndex = 0;
  },
 
  onOK: function() {
        var selIdent;

        var gAccountManager = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);

        var accounts = IdentityReminder.queryISupportsArray(gAccountManager.accounts, Components.interfaces.nsIMsgAccount);

        // accounts.sort(compareAccountSortOrder); TODO!!

        var menulist = document.getElementById('msgIdentity');
        for (var i in accounts) {
            var server = accounts[i].incomingServer;
            if (!server)
                continue;

            var identites = IdentityReminder.queryISupportsArray(accounts[i].identities, Components.interfaces.nsIMsgIdentity);

            for (var j in identites) {
                 var identity = identites[j];
                 if( identity.key == menulist.selectedItem.value )
                 {
                     selIdent = identity;
                 }
            }
        }

	var msgComposeService = Components.classes["@mozilla.org/messengercompose;1"].getService();
 	msgComposeService = msgComposeService.QueryInterface(Components.interfaces.nsIMsgComposeService);
	msgComposeService.OpenComposeWindow(null, null,
	                                    Components.interfaces.nsIMsgCompType.New,
                                            Components.interfaces.nsIMsgCompFormat.Default,
                                            selIdent, null);
  }
};

window.addEventListener("load", function(e) { IdentityReminder.onLoad(e); }, false); 
